/**********************************************************************
 * LeechCraft - modular cross-platform feature rich internet client.
 * Copyright (C) 2011  Minh Ngo
 * Copyright (C) 2011  Georg Rudoy
 *
 * Boost Software License - Version 1.0 - August 17th, 2003
 *
 * Permission is hereby granted, free of charge, to any person or organization
 * obtaining a copy of the software and accompanying documentation covered by
 * this license (the "Software") to use, reproduce, display, distribute,
 * execute, and transmit the Software, and to prepare derivative works of the
 * Software, and to permit third-parties to whom the Software is furnished to
 * do so, all subject to the following:
 *
 * The copyright notices in the Software and this entire statement, including
 * the above license grant, this restriction and the following disclaimer,
 * must be included in all copies of the Software, in whole or in part, and
 * all derivative works of the Software, unless such copies or derivative
 * works are solely in the form of machine-executable object code generated by
 * a source language processor.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE, TITLE AND NON-INFRINGEMENT. IN NO EVENT
 * SHALL THE COPYRIGHT HOLDERS OR ANYONE DISTRIBUTING THE SOFTWARE BE LIABLE
 * FOR ANY DAMAGES OR OTHER LIABILITY, WHETHER IN CONTRACT, TORT OR OTHERWISE,
 * ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
 * DEALINGS IN THE SOFTWARE.
 **********************************************************************/

#include "otzerkaludialog.h"

namespace LeechCraft
{
namespace Otzerkalu
{
	OtzerkaluDialog::OtzerkaluDialog (QWidget *parent)
	: QDialog (parent)
	{
		Ui_.setupUi (this);

		Ui_.SaveDirLineEdit_->setText (QDir::homePath ());
	}

	int OtzerkaluDialog::GetRecursionLevel () const
	{
		return Ui_.RecursionLevel_->value ();
	}

	QString OtzerkaluDialog::GetDir () const
	{
		return Ui_.SaveDirLineEdit_->text ();
	}

	bool OtzerkaluDialog::FetchFromExternalHosts () const
	{
		return Ui_.FromOtherSite_->isChecked ();
	}

	void OtzerkaluDialog::on_ChooseDirButton__clicked ()
	{
		QString saveDir = QFileDialog::getExistingDirectory (this,
				tr ("Save into a directory"),
				QDir::homePath (),
				QFileDialog::ShowDirsOnly |
						QFileDialog::DontResolveSymlinks);
		if (saveDir.isEmpty ())
			return;

		Ui_.SaveDirLineEdit_->setText (saveDir);
	}
}
}
